class ForwardedSSLDetectingFilter(object):
    def __init__(self, app):
        self.app = app
    
    def __call__(self, environ, start_response):
        modified_environ = dict(environ)
        if environ.get('HTTP_X_FORWARDED_SSL', 'off') == 'on':
            modified_environ['wsgi.url_scheme'] = 'https'
        
        return self.app(modified_environ, start_response)

def forwarded_ssl_filter_factory(global_conf):
    return ForwardedSSLDetectingFilter

def forwarded_ssl_filter_app_factory(app, global_conf):
    return ForwardedSSLDetectingFilter(app)
